var math = {};
math.Division = function (num1, num2) {
  var t1 = 0, t2 = 0, r1, r2;
  try {
    t1 = num1.toString().split(".")[1].length;
  } catch (e) { }

  try {
    t2 = num2.toString().split(".")[1].length;
  } catch (e) { }

  r1 = Number(num1.toString().replace(".", ""));
  r2 = Number(num2.toString().replace(".", ""));
  return (r1 / r2) * Math.pow(10, t2 - t1);
}
// 乘法
math.Multiplication = function (num1, num2) {
  var m = 0, s1 = num1.toString(), s2 = num2.toString();
  try {
    m += s1.split(".")[1].length;
  } catch (e) { }

  try {
    m += s2.split(".")[1].length;
  } catch (e) { }

  var v = Number(s1.replace(".", "")) * Number(s2.replace(".", ""));
  return (v / Math.pow(10, m)).toFixed(2);
}
// 加法
math.Addition = function (num1, num2) {
  var r1 = 0, r2 = 0, m;
  try {
    r1 = num1.toString().split(".")[1].length;
  } catch (e) { }

  try {
    r2 = num2.toString().split(".")[1].length;
  } catch (e) { }

  m = Math.pow(10, Math.max(r1, r2));
  return ((num1 * m + num2 * m) / m).toFixed(2);
}
// 减法
math.Subtraction = function (num1, num2) {
  var r1 = 0, r2 = 0, m, n;
  try {
    r1 = num1.toString().split(".")[1].length;
  } catch (e) { }

  try {
    r2 = num2.toString().split(".")[1].length;
  } catch (e) { }

  m = Math.pow(10, Math.max(r1, r2));
  n = (r1 >= r2) ? r1 : r2;
  return ((num1 * m - num2 * m) / m).toFixed(n);
}
export default math